module Dockerploy
  class Image
    def initialize(config, options = {})
      @config = config
      @options = options
    end

    def build
      command = sprintf('env DOCKER_HOST=%s docker build -t %s .', @config.docker_host, image_name)
      ShellClient.new.command(command)
    end

    def push
      command = sprintf('env DOCKER_HOST=%s docker push %s', @config.docker_host, image_name)
      ShellClient.new.command(command)
    end

    def pull
      return unless @config.servers
      @config.servers.each do |server|
        ssh_client = SSHClient.new(server[:host], server[:username], server[:password], server[:port])
        ssh_client.command(sprintf('docker pull %s', image_name))
      end
    end

    private
    def image_name
      @options[:tag] ? sprintf('%s:%s', @config.image_name, @options[:tag]) : @config.image_name
    end
  end
end