module Dockerploy
  class Template
    TEMPLATE_PATH = 'templates/config.yml.erb'.freeze
    CONFIG_PATH = 'docker/config.yml.sample'.freeze

    def self.application_name
      File.basename(Dir.getwd)
    end

    def self.project_name
      shell_client = ShellClient.new
      shell_client.command('git config --get remote.origin.url')
      shell_client.output.match(/([\w-]+\/[\w-]+).git/)[1]
    end

    def self.generate
      namespace = OpenStruct.new(user: ENV['USER'], application_name: self.application_name, project_name: self.project_name)
      template = File.read(File.expand_path(TEMPLATE_PATH, File.dirname(__FILE__)))
      ERB.new(template).result(namespace.instance_eval { binding })
    end

    def self.write
      FileUtils.mkdir_p('docker')
      File.open(CONFIG_PATH, 'w') { |f| f.write(self.generate) }
    end
  end
end
